//ADC SPI receiver

module spirec(CLK, DATA, RCV, RCVD, DIN, AD_CONV);
	input CLK;
	output [31:0] DATA;
	input RCV;				//start receive
	output RCVD;			//data received
	input DIN;				//serial in
	output AD_CONV;			//AD control

	reg [31:0] sh_in=0;
	reg rcvd=0;
	reg adconv=0;
	reg [4:0]dcount=0;
	reg [1:0]eldet=0;	//ldetetls
	reg [1:0]state=0;

	always@(negedge CLK)
		begin
		eldet[0]<=RCV;
		eldet[1]<=eldet[0];
		if(state==2'h0)
			begin
			if(eldet[1:0]==2'b01)
				begin
				adconv=1;
				rcvd=0;
				state<=2'h1;
				end
			else
				begin 
				adconv=0;
				end
			end
		if(state==2'h1)
			begin
			state<=2'h2;
			adconv=0;
			dcount<=5'h00;
			end
		if(state==2'h2)
			begin
			dcount<=dcount+1;
			sh_in[0]<=DIN;
			sh_in[31:1]<=sh_in[30:0];
			if(dcount==5'h1F)
				begin
				rcvd=1;
				state<=2'h0;
				end
			end

		end

	assign DATA=sh_in;
	assign RCVD=rcvd;
	assign AD_CONV=adconv;

endmodule
