//SPI transmitter for DAC

module spitrans(CLK, DATA, TRMT, DOUT, CS, sel_dac);
	input CLK;
    input [11:0] DATA;
    input TRMT;			//start transmit
	input sel_dac;		//1->SPI data for DAC else for amplifier
    output DOUT;		//TxD
	output CS;			//transmit in process

	reg [31:0]shdata=0;	//shift reg.
	reg trans=0;		//ads flag
	reg [4:0]bitsz=0;	//bitszmll
	reg [1:0]eldet=0;	//ldetetls
	reg sel=0;			//sel_dac save

	always@(negedge CLK)
		begin
		eldet[0]<=TRMT;
		eldet[1]<=eldet[0];
		if(eldet[1:0]==2'b01)
			begin
			trans=1;
			bitsz<=5'h0;
			sel<=sel_dac;
			if(sel_dac==1)
				begin
				shdata[3:0]<=4'h0;
				shdata[15:4]<=DATA[11:0];
				shdata[19:16]<=4'hF;
				shdata[23:20]<=4'h3;
				shdata[31:24]<=8'h0;
				end
			else
				begin
				shdata[31:24]<=DATA[7:0];
				end
			end
		else
			begin
			if(trans==1)
				begin
				shdata[31:1]<=shdata[30:0];
				bitsz<=bitsz+1;
				if((bitsz==5'h1F)&(sel==1))trans=0;
				if((bitsz==5'h07)&(sel==0))trans=0;
				end
			else shdata[31]<=0;
			end
		end
		
		assign DOUT=shdata[31];
		assign CS=!trans;

endmodule
